/***********************************************************
constants
***********************************************************/

const nsIWebMailListener = Components.interfaces.nsIWebMailListener;

// UUID uniquely identifying our component
// You can get one from here: http://kruithof.xs4all.nl/uuid/uuidgen
const CLASS_ID = Components.ID("{fe78a2b0-b5f7-11db-abbd-0800200c9a66}");

// description
const CLASS_NAME = "WebMail Notifier Listener";

// textual unique identifier
const CONTRACT_ID = "@mozilla.org/WebMailListener;1";

/***********************************************************
class definition
***********************************************************/

//class constructor
function WebMailListener() {
};

// class definition
WebMailListener.prototype = {
  // define the function we want to expose in our interface
 
  onStatusChange: function(aStatus){},
  
  QueryInterface: function(aIID)
  {
    if (!aIID.equals(nsIWebMailListener) &&    
        !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};

/***********************************************************
class factory

This object is a member of the global-scope Components.classes.
It is keyed off of the contract ID.
***********************************************************/
var WebMailListenerFactory = {
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return (new WebMailListener()).QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var WebMailListenerModule = {
  _firstTime: true,
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, 
        CONTRACT_ID, aFileSpec, aLocation, aType);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
  },
  
  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return WebMailListenerFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },
  canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return WebMailListenerModule; }